diff --git a/CMakeCache.txt b/CMakeCache.txt
index 1da5153502..1968dbd9e2 100644
--- a/CMakeCache.txt
+++ b/CMakeCache.txt
@@ -3121,10 +3121,10 @@ INSTALL_CMAKE_NAMESPACE:STRING=Qt6
 INSTALL_DATADIR:STRING=.
 
 //Module description files directory
-INSTALL_DESCRIPTIONSDIR:STRING=./modules
+INSTALL_DESCRIPTIONSDIR:STRING=modules
 
 //Documentation [DATADIR/doc]
-INSTALL_DOCDIR:STRING=./doc
+INSTALL_DOCDIR:STRING=doc
 
 //Examples [PREFIX/examples]
 INSTALL_EXAMPLESDIR:STRING=examples
@@ -3141,16 +3141,16 @@ INSTALL_LIBDIR:STRING=lib
 
 //Helper programs [ARCHDATADIR/bin on Windows, ARCHDATADIR/libexec
 // otherwise]
-INSTALL_LIBEXECDIR:STRING=./libexec
+INSTALL_LIBEXECDIR:STRING=libexec
 
 //Mkspecs files [PREFIX/mkspecs]
 INSTALL_MKSPECSDIR:STRING=mkspecs
 
 //Plugins [ARCHDATADIR/plugins]
-INSTALL_PLUGINSDIR:STRING=./plugins
+INSTALL_PLUGINSDIR:STRING=plugins
 
 //QML imports [ARCHDATADIR/qml]
-INSTALL_QMLDIR:STRING=./qml
+INSTALL_QMLDIR:STRING=qml
 
 //Settings used by Qt programs [PREFIX/etc/xdg]/[/Library/Preferences/Qt]
 INSTALL_SYSCONFDIR:STRING=etc/xdg
@@ -3159,7 +3159,7 @@ INSTALL_SYSCONFDIR:STRING=etc/xdg
 INSTALL_TESTSDIR:STRING=tests
 
 //Translations [DATADIR/translations]
-INSTALL_TRANSLATIONSDIR:STRING=./translations
+INSTALL_TRANSLATIONSDIR:STRING=translations
 
 //Path to a file.
 Interbase_INCLUDE_DIR:PATH=Interbase_INCLUDE_DIR-NOTFOUND
@@ -4230,9 +4230,6 @@ TIFF_LIBRARY_RELEASE:FILEPATH=/usr/lib/x86_64-linux-gnu/libtiff.so
 //Path to a library.
 Terminfo_LIBRARIES:FILEPATH=/usr/lib/x86_64-linux-gnu/libtinfo.so
 
-//The directory containing a CMake configuration file for Threads.
-Threads_DIR:PATH=Threads_DIR-NOTFOUND
-
 //Path to a file.
 Uabasecpp_INCLUDE_DIRS:PATH=Uabasecpp_INCLUDE_DIRS-NOTFOUND
 
@@ -6182,17 +6179,11 @@ FFMPEG_CFLAGS_OTHER:INTERNAL=
 FFMPEG_DEFINITIONS-ADVANCED:INTERNAL=1
 FFMPEG_FOUND:INTERNAL=1
 FFMPEG_INCLUDEDIR:INTERNAL=
-//ADVANCED property for variable: FFMPEG_INCLUDE_DIRS
-FFMPEG_INCLUDE_DIRS-ADVANCED:INTERNAL=1
 FFMPEG_INCLUDE_DIRS:INTERNAL=/usr/include/x86_64-linux-gnu
 FFMPEG_LDFLAGS:INTERNAL=-L/usr/lib/x86_64-linux-gnu;-lavcodec;-lavformat;-lavutil
 FFMPEG_LDFLAGS_OTHER:INTERNAL=
 FFMPEG_LIBDIR:INTERNAL=
-//ADVANCED property for variable: FFMPEG_LIBRARIES
-FFMPEG_LIBRARIES-ADVANCED:INTERNAL=1
 FFMPEG_LIBRARIES:INTERNAL=avcodec;avformat;avutil
-//ADVANCED property for variable: FFMPEG_LIBRARY_DIRS
-FFMPEG_LIBRARY_DIRS-ADVANCED:INTERNAL=1
 FFMPEG_LIBRARY_DIRS:INTERNAL=/usr/lib/x86_64-linux-gnu
 FFMPEG_LIBS:INTERNAL=
 FFMPEG_LIBS_L:INTERNAL=
@@ -13612,6 +13603,8 @@ X11_INCLUDE_DIRS:INTERNAL=
 X11_LDFLAGS:INTERNAL=-L/usr/lib/x86_64-linux-gnu;-lX11
 X11_LDFLAGS_OTHER:INTERNAL=
 X11_LIBDIR:INTERNAL=/usr/lib/x86_64-linux-gnu
+//ADVANCED property for variable: X11_LIBRARIES
+X11_LIBRARIES-ADVANCED:INTERNAL=1
 X11_LIBRARIES:INTERNAL=X11
 X11_LIBRARY_DIRS:INTERNAL=/usr/lib/x86_64-linux-gnu
 X11_LIBS:INTERNAL=
diff --git a/qtconnectivity/src/tools/sdpscanner/CMakeFiles/sdpscanner_autogen.dir/AutogenInfo.json b/qtconnectivity/src/tools/sdpscanner/CMakeFiles/sdpscanner_autogen.dir/AutogenInfo.json
index de039806b4..5d2c5426c2 100644
--- a/qtconnectivity/src/tools/sdpscanner/CMakeFiles/sdpscanner_autogen.dir/AutogenInfo.json
+++ b/qtconnectivity/src/tools/sdpscanner/CMakeFiles/sdpscanner_autogen.dir/AutogenInfo.json
@@ -6,11 +6,7 @@
 	"CMAKE_EXECUTABLE" : "/d/Qt/Tools/CMake/bin/cmake",
 	"CMAKE_LIST_FILES" : 
 	[
-		"/home/marc/Qt/qt5/qtconnectivity/src/tools/sdpscanner/CMakeLists.txt",
-		"/home/marc/Qt/qt5/qtconnectivity/cmake/FindBlueZ.cmake",
-		"/d/Qt/Tools/CMake/share/cmake-3.23/Modules/FindPkgConfig.cmake",
-		"/d/Qt/Tools/CMake/share/cmake-3.23/Modules/FindPackageHandleStandardArgs.cmake",
-		"/d/Qt/Tools/CMake/share/cmake-3.23/Modules/FindPackageMessage.cmake"
+		"/home/marc/Qt/qt5/qtconnectivity/src/tools/sdpscanner/CMakeLists.txt"
 	],
 	"CMAKE_SOURCE_DIR" : "/home/marc/Qt/qt5",
 	"DEP_FILE" : "/home/marc/Qt/qt5-build-clang/qtconnectivity/src/tools/sdpscanner/sdpscanner_autogen/deps",
diff --git a/qtconnectivity/src/tools/sdpscanner/cmake_install.cmake b/qtconnectivity/src/tools/sdpscanner/cmake_install.cmake
index 0ee6d94ea8..1c3a96e6c0 100644
--- a/qtconnectivity/src/tools/sdpscanner/cmake_install.cmake
+++ b/qtconnectivity/src/tools/sdpscanner/cmake_install.cmake
@@ -44,21 +44,21 @@ endif()
 
 if("x${CMAKE_INSTALL_COMPONENT}x" STREQUAL "xUnspecifiedx" OR NOT CMAKE_INSTALL_COMPONENT)
   if("${CMAKE_INSTALL_CONFIG_NAME}" MATCHES "^([Rr][Ee][Ll][Ww][Ii][Tt][Hh][Dd][Ee][Bb][Ii][Nn][Ff][Oo])$")
-    if(EXISTS "$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/./libexec/sdpscanner" AND
-       NOT IS_SYMLINK "$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/./libexec/sdpscanner")
+    if(EXISTS "$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/libexec/sdpscanner" AND
+       NOT IS_SYMLINK "$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/libexec/sdpscanner")
       file(RPATH_CHECK
-           FILE "$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/./libexec/sdpscanner"
+           FILE "$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/libexec/sdpscanner"
            RPATH "")
     endif()
-    file(INSTALL DESTINATION "${CMAKE_INSTALL_PREFIX}/./libexec" TYPE EXECUTABLE FILES "/home/marc/Qt/qt5-build-clang/qtbase/libexec/sdpscanner")
-    if(EXISTS "$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/./libexec/sdpscanner" AND
-       NOT IS_SYMLINK "$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/./libexec/sdpscanner")
+    file(INSTALL DESTINATION "${CMAKE_INSTALL_PREFIX}/libexec" TYPE EXECUTABLE FILES "/home/marc/Qt/qt5-build-clang/qtbase/libexec/sdpscanner")
+    if(EXISTS "$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/libexec/sdpscanner" AND
+       NOT IS_SYMLINK "$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/libexec/sdpscanner")
       file(RPATH_CHANGE
-           FILE "$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/./libexec/sdpscanner"
+           FILE "$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/libexec/sdpscanner"
            OLD_RPATH "\$ORIGIN/../lib:/home/marc/Qt/qt5-build-clang/qtbase/lib:"
            NEW_RPATH "")
       if(CMAKE_INSTALL_DO_STRIP)
-        execute_process(COMMAND "/home/marc/Qt/qt5-build-clang/qtbase/libexec/qt-internal-strip" "$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/./libexec/sdpscanner")
+        execute_process(COMMAND "/home/marc/Qt/qt5-build-clang/qtbase/libexec/qt-internal-strip" "$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/libexec/sdpscanner")
       endif()
     endif()
   endif("${CMAKE_INSTALL_CONFIG_NAME}" MATCHES "^([Rr][Ee][Ll][Ww][Ii][Tt][Hh][Dd][Ee][Bb][Ii][Nn][Ff][Oo])$")