diff --git a/sources/pyside6/libpyside/dynamicqmetaobject.cpp b/sources/pyside6/libpyside/dynamicqmetaobject.cpp
index a3a16b6a0..c5ee93aee 100644
--- a/sources/pyside6/libpyside/dynamicqmetaobject.cpp
+++ b/sources/pyside6/libpyside/dynamicqmetaobject.cpp
@@ -654,11 +654,11 @@ void MetaObjectBuilderPrivate::parsePythonType(PyTypeObject *type)
     auto collectedEnums = PySide::QEnum::resolveDelayedQEnums(type);
     for (PyObject *obEnumType : collectedEnums) {
         bool isFlag = PySide::QEnum::isFlag(obEnumType);
-        AutoDecRef obName(PyObject_GetAttr(obEnumType, PyMagicName::name()));
+        AutoDecRef obName(PyObject_GetAttr(obEnumType, Shiboken::PyMagicName::name()));
         // Everything has been checked already in resolveDelayedQEnums.
         // Therefore, we don't need to error-check here again.
         auto name = String::toCString(obName);
-        AutoDecRef members(PyObject_GetAttr(obEnumType, PyMagicName::members()));
+        AutoDecRef members(PyObject_GetAttr(obEnumType, Shiboken::PyMagicName::members()));
         AutoDecRef items(PyMapping_Items(members));
         Py_ssize_t nr_items = PySequence_Length(items);
 
diff --git a/sources/pyside6/libpyside/pysideqenum.cpp b/sources/pyside6/libpyside/pysideqenum.cpp
index 3f374b702..a612d5dcd 100644
--- a/sources/pyside6/libpyside/pysideqenum.cpp
+++ b/sources/pyside6/libpyside/pysideqenum.cpp
@@ -132,7 +132,7 @@ PyObject *QEnumMacro(PyObject *pyenum, bool flag)
     if (computedFlag < 0)
         return nullptr;
     if (bool(computedFlag) != flag) {
-        AutoDecRef name(PyObject_GetAttr(pyenum, PyMagicName::qualname()));
+        AutoDecRef name(PyObject_GetAttr(pyenum, Shiboken::PyMagicName::qualname()));
         auto cname = String::toCString(name);
         const char *e = "Enum";
         const char *f = "Flag";
diff --git a/sources/pyside6/libpysideqml/pysideqmlforeign.cpp b/sources/pyside6/libpysideqml/pysideqmlforeign.cpp
index 67aea1756..f9cc4f44d 100644
--- a/sources/pyside6/libpysideqml/pysideqmlforeign.cpp
+++ b/sources/pyside6/libpysideqml/pysideqmlforeign.cpp
@@ -73,7 +73,7 @@ PyTypeObject *PySideQmlForeign_TypeF(void)
 
 } // extern "C"
 
-static const char *qmlAttached_SignatureStrings[] = {
+static const char *qmlForeign_SignatureStrings[] = {
     "PySide6.QtQml.QmlForeign(self,type:type)",
     nullptr // Sentinel
 };
@@ -82,7 +82,7 @@ namespace PySide::Qml {
 
 void initQmlForeign(PyObject *module)
 {
-    if (InitSignatureStrings(PySideQmlForeign_TypeF(), qmlAttached_SignatureStrings) < 0)
+    if (InitSignatureStrings(PySideQmlForeign_TypeF(), qmlForeign_SignatureStrings) < 0)
         return;
 
     Py_INCREF(PySideQmlForeign_TypeF());
diff --git a/sources/shiboken6/libshiboken/sbkfeature_base.cpp b/sources/shiboken6/libshiboken/sbkfeature_base.cpp
index 2931a8abd..8a7b9bf20 100644
--- a/sources/shiboken6/libshiboken/sbkfeature_base.cpp
+++ b/sources/shiboken6/libshiboken/sbkfeature_base.cpp
@@ -33,12 +33,12 @@ int currentSelectId(PyTypeObject *type)
     return sel;
 }
 
-static SelectableFeatureHook SelectFeatureSet = nullptr;
+static SelectableFeatureHook SelectFeatureSetSB = nullptr;
 
 SelectableFeatureHook initSelectableFeature(SelectableFeatureHook func)
 {
-    auto ret = SelectFeatureSet;
-    SelectFeatureSet = func;
+    auto ret = SelectFeatureSetSB;
+    SelectFeatureSetSB = func;
     return ret;
 }
 //
@@ -186,8 +186,8 @@ PyObject *mangled_type_getattro(PyTypeObject *type, PyObject *name)
     static PyTypeObject *const EnumMeta = getPyEnumMeta();
     static PyObject *const _member_map_ = String::createStaticString("_member_map_");
 
-    if (SelectFeatureSet != nullptr)
-        SelectFeatureSet(type);
+    if (SelectFeatureSetSB != nullptr)
+        SelectFeatureSetSB(type);
     auto *ret = type_getattro(reinterpret_cast<PyObject *>(type), name);
 
     // PYSIDE-1735: Be forgiving with strict enums and fetch the enum, silently.
@@ -305,8 +305,8 @@ PyObject *Sbk_TypeGet___dict__(PyTypeObject *type, void * /* context */)
     auto dict = type->tp_dict;
     if (dict == nullptr)
         Py_RETURN_NONE;
-    if (SelectFeatureSet != nullptr) {
-        SelectFeatureSet(type);
+    if (SelectFeatureSetSB != nullptr) {
+        SelectFeatureSetSB(type);
         dict = type->tp_dict;
     }
     return PyDictProxy_New(dict);
@@ -318,16 +318,16 @@ PyObject *Sbk_TypeGet___dict__(PyTypeObject *type, void * /* context */)
 PyObject *SbkObject_GenericGetAttr(PyObject *obj, PyObject *name)
 {
     auto type = Py_TYPE(obj);
-    if (SelectFeatureSet != nullptr)
-        SelectFeatureSet(type);
+    if (SelectFeatureSetSB != nullptr)
+        SelectFeatureSetSB(type);
     return PyObject_GenericGetAttr(obj, name);
 }
 
 int SbkObject_GenericSetAttr(PyObject *obj, PyObject *name, PyObject *value)
 {
     auto type = Py_TYPE(obj);
-    if (SelectFeatureSet != nullptr)
-        SelectFeatureSet(type);
+    if (SelectFeatureSetSB != nullptr)
+        SelectFeatureSetSB(type);
     return PyObject_GenericSetAttr(obj, name, value);
 }
 
@@ -349,8 +349,8 @@ void SbkObjectType_SetEnumFlagInfo(PyTypeObject *type, const char **strings)
 // PYSIDE-1626: Enforcing a context switch without further action.
 void SbkObjectType_UpdateFeature(PyTypeObject *type)
 {
-    if (SelectFeatureSet != nullptr)
-        SelectFeatureSet(type);
+    if (SelectFeatureSetSB != nullptr)
+        SelectFeatureSetSB(type);
 }
 
 } // extern "C"