diff --git a/src/assistant/qlitehtml b/src/assistant/qlitehtml
index bd70f93ce..4931b7aa3 160000
--- a/src/assistant/qlitehtml
+++ b/src/assistant/qlitehtml
@@ -1 +1 @@
-Subproject commit bd70f93ce41443a6a90a269531393f575685283e
+Subproject commit 4931b7aa30f256c20573d283561aa432fecf8f38
diff --git a/src/designer/src/components/propertyeditor/designerpropertymanager.cpp b/src/designer/src/components/propertyeditor/designerpropertymanager.cpp
index bb98d5824..d6945421d 100644
--- a/src/designer/src/components/propertyeditor/designerpropertymanager.cpp
+++ b/src/designer/src/components/propertyeditor/designerpropertymanager.cpp
@@ -2698,6 +2698,7 @@ void DesignerEditorFactory::slotKeySequenceChanged(const QKeySequence &value)
 
 void DesignerEditorFactory::slotPaletteChanged(const QPalette &value)
 {
+    qDebug() << "DesignerEditorFactory::slotPaletteChanged" << sender();
     updateManager(this, &m_changingPropertyValue, m_editorToPaletteProperty, qobject_cast<QWidget *>(sender()), QVariant::fromValue(value));
 }
 
diff --git a/src/designer/src/components/propertyeditor/paletteeditor.cpp b/src/designer/src/components/propertyeditor/paletteeditor.cpp
index b181e8cee..5737a499d 100644
--- a/src/designer/src/components/propertyeditor/paletteeditor.cpp
+++ b/src/designer/src/components/propertyeditor/paletteeditor.cpp
@@ -202,6 +202,8 @@ void PaletteEditor::updateStyledButton()
 QPalette PaletteEditor::getPalette(QDesignerFormEditorInterface *core, QWidget* parent, const QPalette &init,
             const QPalette &parentPal, int *ok)
 {
+    qDebug() << ">PaletteEditor::getPalette" << init
+             << "parent=" << parentPal;
     PaletteEditor dlg(core, parent);
     QPalette parentPalette(parentPal);
     uint mask = init.resolveMask();
@@ -219,6 +221,8 @@ QPalette PaletteEditor::getPalette(QDesignerFormEditorInterface *core, QWidget*
 
     const int result = dlg.exec();
     if (ok) *ok = result;
+    qDebug() << "<PaletteEditor::getPalette" << dlg.palette();
+
 
     return result == QDialog::Accepted ? dlg.palette() : init;
 }
diff --git a/src/designer/src/lib/uilib/formbuilderextra.cpp b/src/designer/src/lib/uilib/formbuilderextra.cpp
index 38e4327b9..61e699b24 100644
--- a/src/designer/src/lib/uilib/formbuilderextra.cpp
+++ b/src/designer/src/lib/uilib/formbuilderextra.cpp
@@ -512,10 +512,17 @@ DomColorGroup *QFormBuilderExtra::saveColorGroup(const QPalette &palette,
     QList<DomColorRole *> colorRoles;
 
     const uint mask = palette.resolveMask();
+
+    qDebug() << "QFormBuilderExtra::saveColorGroup: colorGroup=" << palette
+             << "\ncolorGroup=" << colorGroup
+             << "currentColorGroup=" << palette.currentColorGroup()
+             << "mask=0x" << Qt::hex  << mask;
+
     for (int role = QPalette::WindowText; role < QPalette::NColorRoles; ++role) {
         if (mask & (1 << role)) {
             const QBrush &br = palette.brush(colorGroup, QPalette::ColorRole(role));
-
+            auto col = br.color();
+            qDebug() << __FUNCTION__ << QPalette::ColorRole(role) << col.name();
             DomColorRole *colorRole = new DomColorRole();
             colorRole->setElementBrush(saveBrush(br));
             colorRole->setAttributeRole(QLatin1String(colorRole_enum.valueToKey(role)));
@@ -529,6 +536,7 @@ DomColorGroup *QFormBuilderExtra::saveColorGroup(const QPalette &palette,
 
 DomPalette *QFormBuilderExtra::savePalette(const QPalette &palette)
 {
+    qDebug() << "QFormBuilderExtra::savePalette";
     DomPalette *dom = new DomPalette();
     dom->setElementActive(QFormBuilderExtra::saveColorGroup(palette, QPalette::Active));
     dom->setElementInactive(QFormBuilderExtra::saveColorGroup(palette, QPalette::Inactive));
diff --git a/src/designer/src/lib/uilib/properties.cpp b/src/designer/src/lib/uilib/properties.cpp
index 8e31bef7c..7723126b5 100644
--- a/src/designer/src/lib/uilib/properties.cpp
+++ b/src/designer/src/lib/uilib/properties.cpp
@@ -58,6 +58,8 @@ QVariant domPropertyToVariant(QAbstractFormBuilder *afb,const QMetaObject *meta,
             afb->setupColorGroup(palette, QPalette::Disabled, dom->elementDisabled());
 
         palette.setCurrentColorGroup(QPalette::Active);
+        qDebug() << __FUNCTION__  << palette;
+
         return QVariant::fromValue(palette);
     }
 
@@ -601,8 +603,10 @@ DomProperty *variantToDomProperty(QAbstractFormBuilder *afb, const QMetaObject *
     // Complex properties
     switch (v.metaType().id()) {
     case QMetaType::QPalette: {
+
         DomPalette *dom = new DomPalette();
         QPalette palette = qvariant_cast<QPalette>(v);
+        qDebug() << __FUNCTION__  << palette;
 
         palette.setCurrentColorGroup(QPalette::Active);
         dom->setElementActive(afb->saveColorGroup(palette));