diff --git a/src/assistant/qlitehtml b/src/assistant/qlitehtml
index bd70f93ce..4931b7aa3 160000
--- a/src/assistant/qlitehtml
+++ b/src/assistant/qlitehtml
@@ -1 +1 @@
-Subproject commit bd70f93ce41443a6a90a269531393f575685283e
+Subproject commit 4931b7aa30f256c20573d283561aa432fecf8f38
diff --git a/src/designer/src/components/propertyeditor/designerpropertymanager.cpp b/src/designer/src/components/propertyeditor/designerpropertymanager.cpp
index ee67c0826..32c6e2dd6 100644
--- a/src/designer/src/components/propertyeditor/designerpropertymanager.cpp
+++ b/src/designer/src/components/propertyeditor/designerpropertymanager.cpp
@@ -2699,6 +2699,7 @@ void DesignerEditorFactory::slotKeySequenceChanged(const QKeySequence &value)
 
 void DesignerEditorFactory::slotPaletteChanged(const QPalette &value)
 {
+    qDebug() << "DesignerEditorFactory::slotPaletteChanged" << sender();
     updateManager(this, &m_changingPropertyValue, m_editorToPaletteProperty, qobject_cast<QWidget *>(sender()), QVariant::fromValue(value));
 }
 
diff --git a/src/designer/src/components/propertyeditor/paletteeditor.cpp b/src/designer/src/components/propertyeditor/paletteeditor.cpp
index 331750f5b..2efb63bd0 100644
--- a/src/designer/src/components/propertyeditor/paletteeditor.cpp
+++ b/src/designer/src/components/propertyeditor/paletteeditor.cpp
@@ -200,6 +200,8 @@ void PaletteEditor::updateStyledButton()
 QPalette PaletteEditor::getPalette(QDesignerFormEditorInterface *core, QWidget* parent, const QPalette &init,
             const QPalette &parentPal, int *ok)
 {
+    qDebug() << ">PaletteEditor::getPalette" << init
+             << "parent=" << parentPal;
     PaletteEditor dlg(core, parent);
     QPalette parentPalette(parentPal);
     for (int r = 0; r < static_cast<int>(QPalette::NColorRoles); ++r) {
@@ -214,6 +216,8 @@ QPalette PaletteEditor::getPalette(QDesignerFormEditorInterface *core, QWidget*
 
     const int result = dlg.exec();
     if (ok) *ok = result;
+    qDebug() << "<PaletteEditor::getPalette" << dlg.palette();
+
 
     return result == QDialog::Accepted ? dlg.palette() : init;
 }
@@ -475,6 +479,7 @@ bool PaletteModel::setData(const QModelIndex &index, const QVariant &value, int
         auto resolveMask = m_palette.resolveMask();
         const bool isMask = qvariant_cast<bool>(value);
         const auto bitMask = rowMask(index);
+        qDebug() << __FUNCTION__ << Qt::hex << "bitMask=" << bitMask << "resolveMask=" << resolveMask;
         if (isMask)
             resolveMask |= bitMask;
         else { // Reset row
diff --git a/src/designer/src/lib/shared/qdesigner_propertycommand.cpp b/src/designer/src/lib/shared/qdesigner_propertycommand.cpp
index 4ce80d09e..317f35b85 100644
--- a/src/designer/src/lib/shared/qdesigner_propertycommand.cpp
+++ b/src/designer/src/lib/shared/qdesigner_propertycommand.cpp
@@ -274,6 +274,7 @@ quint64 compareSubProperties(const QPalette & p1, const QPalette & p2)
             }
         }
     }
+    qDebug() << __FUNCTION__ << p1 << p2 << Qt::hex << rc;
 
     return rc;
 }
@@ -475,6 +476,7 @@ QPalette applyPaletteSubProperty(const QPalette &oldValue, const QPalette &newVa
             rc.setResolveMask(resolveMask);
         }
     }
+    qDebug() << __FUNCTION__ << Qt::hex << mask << Qt::dec << rc;
     return rc;
 }
 
diff --git a/src/designer/src/lib/uilib/formbuilderextra.cpp b/src/designer/src/lib/uilib/formbuilderextra.cpp
index 260bf08d1..6939a6bb9 100644
--- a/src/designer/src/lib/uilib/formbuilderextra.cpp
+++ b/src/designer/src/lib/uilib/formbuilderextra.cpp
@@ -528,6 +528,7 @@ DomColorGroup *QFormBuilderExtra::saveColorGroup(const QPalette &palette,
 
 DomPalette *QFormBuilderExtra::savePalette(const QPalette &palette)
 {
+    qDebug() << "QFormBuilderExtra::savePalette";
     DomPalette *dom = new DomPalette();
     dom->setElementActive(QFormBuilderExtra::saveColorGroup(palette, QPalette::Active));
     dom->setElementInactive(QFormBuilderExtra::saveColorGroup(palette, QPalette::Inactive));
diff --git a/src/designer/src/lib/uilib/properties.cpp b/src/designer/src/lib/uilib/properties.cpp
index 8e31bef7c..3299a47cd 100644
--- a/src/designer/src/lib/uilib/properties.cpp
+++ b/src/designer/src/lib/uilib/properties.cpp
@@ -58,6 +58,8 @@ QVariant domPropertyToVariant(QAbstractFormBuilder *afb,const QMetaObject *meta,
             afb->setupColorGroup(palette, QPalette::Disabled, dom->elementDisabled());
 
         palette.setCurrentColorGroup(QPalette::Active);
+        qDebug() << __FUNCTION__  << palette;
+
         return QVariant::fromValue(palette);
     }
 
@@ -603,6 +605,7 @@ DomProperty *variantToDomProperty(QAbstractFormBuilder *afb, const QMetaObject *
     case QMetaType::QPalette: {
         DomPalette *dom = new DomPalette();
         QPalette palette = qvariant_cast<QPalette>(v);
+        qDebug() << __FUNCTION__  << palette;
 
         palette.setCurrentColorGroup(QPalette::Active);
         dom->setElementActive(afb->saveColorGroup(palette));